Index: frontends/php/api/classes/class.ctemplate.php
===================================================================
--- frontends/php/api/classes/class.ctemplate.php	(revision 38884)
+++ frontends/php/api/classes/class.ctemplate.php	(working copy)
@@ -333,7 +333,7 @@
 			zbx_value2array($options['filter']);
 
 			if(isset($options['filter']['templateid'])){
-				$sql_parts['where']['templateid'] = 'h.hostid='.$options['filter']['templateid'];
+				$sql_parts['where']['templateid'] = 'h.hostid='.zbx_dbstr($options['filter']['templateid']);
 			}
 			if(isset($options['filter']['host'])){
 				$sql_parts['where']['host'] = 'h.host='.zbx_dbstr($options['filter']['host']);
Index: frontends/php/api/classes/class.cmap.php
===================================================================
--- frontends/php/api/classes/class.cmap.php	(revision 38884)
+++ frontends/php/api/classes/class.cmap.php	(working copy)
@@ -146,7 +146,7 @@
 			zbx_value2array($options['filter']);
 
 			if(isset($options['filter']['sysmapid'])){
-				$sql_parts['where']['sysmapid'] = 's.sysmapid='.$options['filter']['sysmapid'];
+				$sql_parts['where']['sysmapid'] = 's.sysmapid='.zbx_dbstr($options['filter']['sysmapid']);
 			}
 			if(isset($options['filter']['name'])){
 				$sql_parts['where']['name'] = 's.name='.zbx_dbstr($options['filter']['name']);
@@ -530,8 +530,8 @@
 
 			$sysmapid=get_dbid('sysmaps','sysmapid');
 			$result=DBexecute('INSERT INTO sysmaps (sysmapid,name,width,height,backgroundid,highlight,label_type,label_location)'.
-					' VALUES ('.$sysmapid.','.zbx_dbstr($map['name']).','.$map['width'].','.$map['height'].','.
-								$map['backgroundid'].','.$map['highlight'].','.$map['label_type'].','.$map['label_location'].')');
+					' VALUES ('.$sysmapid.','.zbx_dbstr($map['name']).','.zbx_dbstr($map['width']).','.zbx_dbstr($map['height']).','.
+						zbx_dbstr($map['backgroundid']).','.zbx_dbstr($map['highlight']).','.zbx_dbstr($map['label_type']).','.zbx_dbstr($map['label_location']).')');
 
 			if(!$result) break;
 
@@ -616,13 +616,13 @@
 			
 			$sql = 'UPDATE sysmaps '.
 					' SET name='.zbx_dbstr($map['name']).','.
-						' width='.$map['width'].','.
-						' height='.$map['height'].','.
-						' backgroundid='.$map['backgroundid'].','.
-						' highlight='.$map['highlight'].','.
-						' label_type='.$map['label_type'].','.
-						' label_location='.$map['label_location'].
-					' WHERE sysmapid='.$map['sysmapid'];
+						' width='.zbx_dbstr($map['width']).','.
+						' height='.zbx_dbstr($map['height']).','.
+						' backgroundid='.zbx_dbstr($map['backgroundid']).','.
+						' highlight='.zbx_dbstr($map['highlight']).','.
+						' label_type='.zbx_dbstr($map['label_type']).','.
+						' label_location='.zbx_dbstr($map['label_location']).
+					' WHERE sysmapid='.zbx_dbstr($map['sysmapid']);
 			$result = DBexecute($sql);
 
 			if(!$result) break;
@@ -916,8 +916,8 @@
 
 			$linktriggerid = get_dbid('sysmaps_link_triggers', 'linktriggerid');
 			$sql = 'INSERT INTO sysmaps_link_triggers (linktriggerid, linkid, triggerid, drawtype, color) '.
-				' VALUES ('.$linktriggerid.','.$linktrigger['linkid'].','.$linktrigger['triggerid'].', '.
-					$linktrigger['drawtype'].','.zbx_dbstr($linktrigger['color']).')';
+				' VALUES ('.$linktriggerid.','.zbx_dbstr($linktrigger['linkid']).','.zbx_dbstr($linktrigger['triggerid']).', '.
+					zbx_dbstr($linktrigger['drawtype']).','.zbx_dbstr($linktrigger['color']).')';
 			$result = DBexecute($sql);
 			if(!$result){
 				$result = false;
Index: frontends/php/api/classes/class.caction.php
===================================================================
--- frontends/php/api/classes/class.caction.php	(revision 38884)
+++ frontends/php/api/classes/class.caction.php	(working copy)
@@ -332,27 +332,27 @@
 
 // eventsource
 		if(!is_null($options['eventsource'])){
-			$sql_parts['where'][] = 'a.eventsource='.$options['eventsource'];
+			$sql_parts['where'][] = 'a.eventsource='.zbx_dbstr($options['eventsource']);
 		}
 
 // evaltype
 		if(!is_null($options['evaltype'])){
-			$sql_parts['where'][] = 'a.evaltype='.$options['evaltype'];
+			$sql_parts['where'][] = 'a.evaltype='.zbx_dbstr($options['evaltype']);
 		}
 
 // status
 		if(!is_null($options['status'])){
-			$sql_parts['where'][] = 'a.status='.$options['status'];
+			$sql_parts['where'][] = 'a.status='.zbx_dbstr($options['status']);
 		}
 
 // esc_period
 		if(!is_null($options['esc_period'])){
-			$sql_parts['where'][] = 'a.esc_period>'.$options['esc_period'];
+			$sql_parts['where'][] = 'a.esc_period>'.zbx_dbstr($options['esc_period']);
 		}
 
 // recovery_msg
 		if(!is_null($options['recovery_msg'])){
-			$sql_parts['where'][] = 'a.recovery_msg<'.$options['recovery_msg'];
+			$sql_parts['where'][] = 'a.recovery_msg<'.zbx_dbstr($options['recovery_msg']);
 		}
 
 // extendoutput
@@ -566,15 +566,15 @@
 				$values = array(
 					'actionid' => $actionid,
 					'name' => zbx_dbstr($action['name']),
-					'eventsource' => $action['eventsource'],
-					'esc_period' => $action['esc_period'],
+					'eventsource' => zbx_dbstr($action['eventsource']),
+					'esc_period' => zbx_dbstr($action['esc_period']),
 					'def_shortdata' => zbx_dbstr($action['def_shortdata']),
 					'def_longdata' => zbx_dbstr($action['def_longdata']),
 					'recovery_msg' => zbx_dbstr($action['recovery_msg']),
 					'r_shortdata' => zbx_dbstr($action['r_shortdata']),
 					'r_longdata' => zbx_dbstr($action['r_longdata']),
-					'evaltype' => $action['evaltype'],
-					'status' => $action['status']
+					'evaltype' => zbx_dbstr($action['evaltype']),
+					'status' => zbx_dbstr($action['status'])
 				);
 
 
@@ -721,9 +721,9 @@
 			$conditionid = get_dbid('conditions','conditionid');
 			$values = array(
 				'conditionid' => $conditionid,
-				'actionid' => $condition['actionid'],
-				'conditiontype' => $condition['conditiontype'],
-				'operator' => $condition['operator'],
+				'actionid' => zbx_dbstr($condition['actionid']),
+				'conditiontype' => zbx_dbstr($condition['conditiontype']),
+				'operator' => zbx_dbstr($condition['operator']),
 				'value' => zbx_dbstr($condition['value'])
 			);
 
@@ -809,17 +809,17 @@
 			$operationid = get_dbid('operations','operationid');
 			$values = array(
 				'operationid' => $operationid,
-				'actionid' => $operation['actionid'],
-				'operationtype' => $operation['operationtype'],
-				'object' => $operation['object'],
-				'objectid' => $operation['objectid'],
-				'shortdata' => zbx_dbstr($operation['shortdata']),
-				'longdata' => zbx_dbstr($operation['longdata']),
-				'esc_period' => $operation['esc_period'],
-				'esc_step_from' => $operation['esc_step_from'],
-				'esc_step_to' => $operation['esc_step_to'],
-				'default_msg' => $operation['default_msg'],
-				'evaltype' => $operation['evaltype']
+				'actionid' => zbx_dbstr($operation['actionid']),
+				'operationtype' => zbx_dbstr($operation['operationtype']),
+				'object' => zbx_dbstr($operation['object']),
+				'objectid' => zbx_dbstr($operation['objectid']),
+				'shortdata' => zbx_dbstr(zbx_dbstr($operation['shortdata'])),
+				'longdata' => zbx_dbstr(zbx_dbstr($operation['longdata'])),
+				'esc_period' => zbx_dbstr($operation['esc_period']),
+				'esc_step_from' => zbx_dbstr($operation['esc_step_from']),
+				'esc_step_to' => zbx_dbstr($operation['esc_step_to']),
+				'default_msg' => zbx_dbstr($operation['default_msg']),
+				'evaltype' => zbx_dbstr($operation['evaltype'])
 			);
 
 			$result = DBexecute('INSERT INTO operations ('.implode(',', array_keys($values)).')'.
@@ -833,8 +833,8 @@
 				$result &= (bool) DBexecute('INSERT INTO opconditions (opconditionid,operationid,conditiontype,operator,value)'.
 					' values ('.$opconditionid.','.
 						$operationid.','.
-						$opcondition['conditiontype'].','.
-						$opcondition['operator'].','.
+						zbx_dbstr($opcondition['conditiontype']).','.
+						zbx_dbstr($opcondition['operator']).','.
 						zbx_dbstr($opcondition['value']).
 					')');
 			}
Index: frontends/php/api/classes/class.chost.php
===================================================================
--- frontends/php/api/classes/class.chost.php	(revision 38884)
+++ frontends/php/api/classes/class.chost.php	(working copy)
@@ -425,7 +425,7 @@
 			zbx_value2array($options['filter']);
 
 			if(isset($options['filter']['hostid']) && !is_null($options['filter']['hostid'])){
-				$sql_parts['where']['hostid'] = 'h.hostid='.$options['filter']['hostid'];
+				$sql_parts['where']['hostid'] = 'h.hostid='.zbx_dbstr($options['filter']['hostid']);
 			}
 
 			if(isset($options['filter']['host']) && !is_null($options['filter']['host'])){
@@ -1036,19 +1036,19 @@
 			$result = DBexecute('INSERT INTO hosts (hostid, proxy_hostid, host, port, status, useip, dns, ip, disable_until, available,'.
 				'useipmi,ipmi_port,ipmi_authtype,ipmi_privilege,ipmi_username,ipmi_password,ipmi_ip) VALUES ('.
 				$hostid.','.
-				$host['proxy_hostid'].','.
+				zbx_dbstr($host['proxy_hostid']).','.
 				zbx_dbstr($host['host']).','.
-				$host['port'].','.
-				$host['status'].','.
-				$host['useip'].','.
+				zbx_dbstr($host['port']).','.
+				zbx_dbstr($host['status']).','.
+				zbx_dbstr($host['useip']).','.
 				zbx_dbstr($host['dns']).','.
 				zbx_dbstr($host['ip']).
 				',0,'.
 				HOST_AVAILABLE_UNKNOWN.','.
-				$host['useipmi'].','.
-				$host['ipmi_port'].','.
-				$host['ipmi_authtype'].','.
-				$host['ipmi_privilege'].','.
+				zbx_dbstr($host['useipmi']).','.
+				zbx_dbstr($host['ipmi_port']).','.
+				zbx_dbstr($host['ipmi_authtype']).','.
+				zbx_dbstr($host['ipmi_privilege']).','.
 				zbx_dbstr($host['ipmi_username']).','.
 				zbx_dbstr($host['ipmi_password']).','.
 				zbx_dbstr($host['ipmi_ip']).')'
@@ -1324,17 +1324,17 @@
 			}
 
 			$sql_set = array();
-			if(isset($data['proxy_hostid'])) $sql_set[] = 'proxy_hostid='.$data['proxy_hostid'];
+			if(isset($data['proxy_hostid'])) $sql_set[] = 'proxy_hostid='.zbx_dbstr($data['proxy_hostid']);
 			if(isset($data['host'])) $sql_set[] = 'host='.zbx_dbstr($data['host']);
-			if(isset($data['port'])) $sql_set[] = 'port='.$data['port'];
-			if(isset($data['status'])) $sql_set[] = 'status='.$data['status'];
-			if(isset($data['useip'])) $sql_set[] = 'useip='.$data['useip'];
+			if(isset($data['port'])) $sql_set[] = 'port='.zbx_dbstr($data['port']);
+			if(isset($data['status'])) $sql_set[] = 'status='.zbx_dbstr($data['status']);
+			if(isset($data['useip'])) $sql_set[] = 'useip='.zbx_dbstr($data['useip']);
 			if(isset($data['dns'])) $sql_set[] = 'dns='.zbx_dbstr($data['dns']);
 			if(isset($data['ip'])) $sql_set[] = 'ip='.zbx_dbstr($data['ip']);
-			if(isset($data['useipmi'])) $sql_set[] = 'useipmi='.$data['useipmi'];
-			if(isset($data['ipmi_port'])) $sql_set[] = 'ipmi_port='.$data['ipmi_port'];
-			if(isset($data['ipmi_authtype'])) $sql_set[] = 'ipmi_authtype='.$data['ipmi_authtype'];
-			if(isset($data['ipmi_privilege'])) $sql_set[] = 'ipmi_privilege='.$data['ipmi_privilege'];
+			if(isset($data['useipmi'])) $sql_set[] = 'useipmi='.zbx_dbstr($data['useipmi']);
+			if(isset($data['ipmi_port'])) $sql_set[] = 'ipmi_port='.zbx_dbstr($data['ipmi_port']);
+			if(isset($data['ipmi_authtype'])) $sql_set[] = 'ipmi_authtype='.zbx_dbstr($data['ipmi_authtype']);
+			if(isset($data['ipmi_privilege'])) $sql_set[] = 'ipmi_privilege='.zbx_dbstr($data['ipmi_privilege']);
 			if(isset($data['ipmi_username'])) $sql_set[] = 'ipmi_username='.zbx_dbstr($data['ipmi_username']);
 			if(isset($data['ipmi_password'])) $sql_set[] = 'ipmi_password='.zbx_dbstr($data['ipmi_password']);
 			if(isset($data['ipmi_ip'])) $sql_set[] = 'ipmi_ip='.zbx_dbstr($data['ipmi_ip']);
Index: frontends/php/api/classes/class.cuser.php
===================================================================
--- frontends/php/api/classes/class.cuser.php	(revision 38884)
+++ frontends/php/api/classes/class.cuser.php	(working copy)
@@ -149,7 +149,7 @@
 
 // type
 		if(!is_null($options['type'])){
-			$sql_parts['where'][] = 'u.type='.$options['type'];
+			$sql_parts['where'][] = 'u.type='.zbx_dbstr($options['type']);
 		}
 
 
@@ -703,13 +703,13 @@
 					zbx_dbstr($user['alias']).','.
 					zbx_dbstr(md5($user['passwd'])).','.
 					zbx_dbstr($user['url']).','.
-					$user['autologin'].','.
-					$user['autologout'].','.
+					zbx_dbstr($user['autologin']).','.
+					zbx_dbstr($user['autologout']).','.
 					zbx_dbstr($user['lang']).','.
 					zbx_dbstr($user['theme']).','.
-					$user['refresh'].','.
-					$user['rows_per_page'].','.
-					$user['type'].
+					zbx_dbstr($user['refresh']).','.
+					zbx_dbstr($user['rows_per_page']).','.
+					zbx_dbstr($user['type']).
 				')');
 
 			if($result){
@@ -718,7 +718,7 @@
 					if(!$result) break;
 					$users_groups_id = get_dbid("users_groups","id");
 					$result = DBexecute('INSERT INTO users_groups (id,usrgrpid,userid)'.
-						'values('.$users_groups_id.','.$groupid.','.$userid.')');
+						'values('.$users_groups_id.','.zbx_dbstr($groupid).','.zbx_dbstr($userid).')');
 				}
 			}
 
@@ -727,8 +727,8 @@
 					if(!$result) break;
 					$mediaid = get_dbid('media', 'mediaid');
 					$result = DBexecute('INSERT INTO media (mediaid,userid,mediatypeid,sendto,active,severity,period)'.
-						' VALUES ('.$mediaid.','.$userid.','.$media_data['mediatypeid'].','.
-						zbx_dbstr($media_data['sendto']).','.$media_data['active'].','.$media_data['severity'].','.
+						' VALUES ('.$mediaid.','.zbx_dbstr($userid).','.zbx_dbstr($media_data['mediatypeid']).','.
+						zbx_dbstr($media_data['sendto']).','.zbx_dbstr($media_data['active']).','.zbx_dbstr($media_data['severity']).','.
 						zbx_dbstr($media_data['period']).')');
 				}
 			}
@@ -853,14 +853,14 @@
 						' alias='.zbx_dbstr($user['alias']).', '.
 						' passwd='.zbx_dbstr($user['passwd']).', '.
 						' url='.zbx_dbstr($user['url']).', '.
-						' autologin='.$user['autologin'].', '.
-						' autologout='.$user['autologout'].', '.
+						' autologin='.zbx_dbstr($user['autologin']).', '.
+						' autologout='.zbx_dbstr($user['autologout']).', '.
 						' lang='.zbx_dbstr($user['lang']).', '.
 						' theme='.zbx_dbstr($user['theme']).', '.
-						' refresh='.$user['refresh'].', '.
-						' rows_per_page='.$user['rows_per_page'].', '.
-						' type='.$user['type'].
-					' WHERE userid='.$user['userid'];
+						' refresh='.zbx_dbstr($user['refresh']).', '.
+						' rows_per_page='.zbx_dbstr($user['rows_per_page']).', '.
+						' type='.zbx_dbstr($user['type']).
+					' WHERE userid='.zbx_dbstr($user['userid']);
 
 			$result = DBexecute($sql);
 
@@ -884,7 +884,7 @@
 
 
 			if($result && isset($user['usrgrps']) && !is_null($user['usrgrps'])){
-				DBexecute('DELETE FROM users_groups WHERE userid='.$user['userid']);
+				DBexecute('DELETE FROM users_groups WHERE userid='.zbx_dbstr($user['userid']));
 
 				$usrgrps = CUserGroup::get(array(
 					'usrgrpids' => zbx_objectValues($user['usrgrps'], 'usrgrpid'),
@@ -907,7 +907,7 @@
 					}
 
 					$users_groups_id = get_dbid('users_groups', 'id');
-					$result = DBexecute('INSERT INTO users_groups (id, usrgrpid, userid) VALUES ('.$users_groups_id.','.$groupid.','.$user['userid'].')');
+					$result = DBexecute('INSERT INTO users_groups (id, usrgrpid, userid) VALUES ('.$users_groups_id.','.zbx_dbstr($groupid).','.zbx_dbstr($user['userid']).')');
 				}
 			}
 /*
@@ -1009,13 +1009,13 @@
 		$sql = 'UPDATE users SET '.
 					' passwd='.zbx_dbstr($user['passwd']).', '.
 					' url='.zbx_dbstr($user['url']).', '.
-					' autologin='.$user['autologin'].', '.
-					' autologout='.$user['autologout'].', '.
+					' autologin='.zbx_dbstr($user['autologin']).', '.
+					' autologout='.zbx_dbstr($user['autologout']).', '.
 					' lang='.zbx_dbstr($user['lang']).', '.
 					' theme='.zbx_dbstr($user['theme']).', '.
-					' refresh='.$user['refresh'].', '.
-					' rows_per_page='.$user['rows_per_page'].
-				' WHERE userid='.$user['userid'];
+					' refresh='.zbx_dbstr($user['refresh']).', '.
+					' rows_per_page='.zbx_dbstr($user['rows_per_page']).
+				' WHERE userid='.zbx_dbstr($user['userid']);
 
 		$result = DBexecute($sql);
 
@@ -1146,8 +1146,8 @@
 					$mediaid = get_dbid('media','mediaid');
 
 					$sql='INSERT INTO media (mediaid,userid,mediatypeid,sendto,active,severity,period) '.
-							' VALUES ('.$mediaid.','.$user['userid'].','.$media['mediatypeid'].','.
-										zbx_dbstr($media['sendto']).','.$media['active'].','.$media['severity'].','.
+							' VALUES ('.$mediaid.','.$user['userid'].','.zbx_dbstr($media['mediatypeid']).','.
+										zbx_dbstr($media['sendto']).','.zbx_dbstr($media['active']).','.zbx_dbstr($media['severity']).','.
 										zbx_dbstr($media['period']).')';
 
 					$result = DBexecute($sql);
@@ -1276,12 +1276,12 @@
 				}
 
 				$sql = 'UPDATE media '.
-						' SET mediatypeid='.$media['mediatypeid'].','.
+						' SET mediatypeid='.zbx_dbstr($media['mediatypeid']).','.
 							' sendto='.zbx_dbstr($media['sendto']).','.
-							' active='.$media['active'].','.
-							' severity='.$media['severity'].','.
+							' active='.zbx_dbstr($media['active']).','.
+							' severity='.zbx_dbstr($media['severity']).','.
 							' period='.zbx_dbstr($media['period']).
-						' WHERE mediaid='.$media['mediaid'];
+						' WHERE mediaid='.zbx_dbstr($media['mediaid']);
 				$result = DBexecute($sql);
 				if(!$result){
 					throw new APIException(ZBX_API_ERROR_PARAMETERS, 'Can\'t update user media');
Index: frontends/php/api/classes/class.cscreen.php
===================================================================
--- frontends/php/api/classes/class.cscreen.php	(revision 38884)
+++ frontends/php/api/classes/class.cscreen.php	(working copy)
@@ -130,7 +130,7 @@
 			zbx_value2array($options['filter']);
 
 			if(isset($options['filter']['screenid'])){
-				$sql_parts['where']['screenid'] = 's.screenid='.$options['filter']['screenid'];
+				$sql_parts['where']['screenid'] = 's.screenid='.zbx_dbstr($options['filter']['screenid']);
 			}
 			if(isset($options['filter']['name'])){
 				$sql_parts['where']['name'] = 's.name='.zbx_dbstr($options['filter']['name']);
@@ -503,8 +503,8 @@
 				$values = array(
 					'screenid' => $screenid,
 					'name' => zbx_dbstr($screen['name']),
-					'hsize' => $screen['hsize'],
-					'vsize' => $screen['vsize']
+					'hsize' => zbx_dbstr($screen['hsize']),
+					'vsize' => zbx_dbstr($screen['vsize'])
 				);
 				$sql = 'INSERT INTO screens ('.implode(',',array_keys($values)).') '.
 						' VALUES ('.implode(',',array_values($values)).')';
@@ -602,13 +602,13 @@
 
 				$values = array(
 					'name' => zbx_dbstr($screen['name']),
-					'hsize' => $screen['hsize'],
-					'vsize' => $screen['vsize']
+					'hsize' => zbx_dbstr($screen['hsize']),
+					'vsize' => zbx_dbstr($screen['vsize'])
 				);
 
 				$sql = 'UPDATE screens '.
 						' SET '.zbx_implodeHash(',','=',$values).
-						' WHERE	screenid='.$screen['screenid'];
+						' WHERE	screenid='.zbx_dbstr($screen['screenid']);
 				$result = DBexecute($sql);
 
 // Screen items
@@ -779,21 +779,21 @@
 					$screenitemid = get_dbid('screens_items', 'screenitemid');
 					$values = array(
 						'screenitemid' => $screenitemid,
-						'screenid' => $screenid,
-						'resourcetype' => $screenItem['resourcetype'],
-						'resourceid' => $screenItem['resourceid'],
-						'width' => $screenItem['width'],
-						'height' => $screenItem['height'],
-						'x' => $screenItem['x'],
-						'y' => $screenItem['y'],
-						'colspan' => $screenItem['colspan'],
-						'rowspan' => $screenItem['rowspan'],
-						'elements' => $screenItem['elements'],
-						'valign' => $screenItem['valign'],
-						'halign' => $screenItem['halign'],
-						'style' => $screenItem['style'],
+						'screenid' => zbx_dbstr($screenid),
+						'resourcetype' => zbx_dbstr($screenItem['resourcetype']),
+						'resourceid' => zbx_dbstr($screenItem['resourceid']),
+						'width' => zbx_dbstr($screenItem['width']),
+						'height' => zbx_dbstr($screenItem['height']),
+						'x' => zbx_dbstr($screenItem['x']),
+						'y' => zbx_dbstr($screenItem['y']),
+						'colspan' => zbx_dbstr($screenItem['colspan']),
+						'rowspan' => zbx_dbstr($screenItem['rowspan']),
+						'elements' => zbx_dbstr($screenItem['elements']),
+						'valign' => zbx_dbstr($screenItem['valign']),
+						'halign' => zbx_dbstr($screenItem['halign']),
+						'style' => zbx_dbstr($screenItem['style']),
 						'url' => zbx_dbstr($screenItem['url']),
-						'dynamic' => $screenItem['dynamic']
+						'dynamic' => zbx_dbstr($screenItem['dynamic'])
 					);
 
 
Index: frontends/php/api/classes/class.cgraphitem.php
===================================================================
--- frontends/php/api/classes/class.cgraphitem.php	(revision 38884)
+++ frontends/php/api/classes/class.cgraphitem.php	(working copy)
@@ -130,7 +130,7 @@
 		}
 // type
 		if(!is_null($options['type'] )){
-			$sql_parts['where'][] = 'gi.type='.$options['type'];
+			$sql_parts['where'][] = 'gi.type='.zbx_dbstr($options['type']);
 		}
 // extendoutput
 		if($options['output'] == API_OUTPUT_EXTEND){
@@ -249,8 +249,8 @@
 
 		$sql = 'SELECT gi.gitemid '.
 				' FROM graphs_items gi '.
-				' WHERE gi.itemid='.$gitem_data['itemid'].
-					' AND gi.graphid='.$gitem_data['graphid'].
+				' WHERE gi.itemid='.zbx_dbstr($gitem_data['itemid']).
+					' AND gi.graphid='.zbx_dbstr($gitem_data['graphid']);
 		$db_res = DBselect($sql);
 		while($gitem = DBfetch($db_res)){
 			$gitemids[$gitem['gitemid']] = $gitem['gitemid'];
Index: frontends/php/api/classes/class.cevent.php
===================================================================
--- frontends/php/api/classes/class.cevent.php	(revision 38884)
+++ frontends/php/api/classes/class.cevent.php	(working copy)
@@ -205,7 +205,7 @@
 		}
 // object
 		if(!is_null($options['object'])){
-			$sql_parts['where']['o'] = 'e.object='.$options['object'];
+			$sql_parts['where']['o'] = 'e.object='.zbx_dbstr($options['object']);
 		}
 // triggerids
 		if(!is_null($options['triggerids']) && ($options['object'] == EVENT_OBJECT_TRIGGER)){
@@ -214,7 +214,7 @@
 		}
 // source
 		if(!is_null($options['source'])){
-			$sql_parts['where'][] = 'e.source='.$options['source'];
+			$sql_parts['where'][] = 'e.source='.zbx_dbstr($options['source']);
 		}
 // acknowledged
 		if(!is_null($options['acknowledged'])){
@@ -226,11 +226,11 @@
 		}
 // time_from
 		if(!is_null($options['time_from'])){
-			$sql_parts['where'][] = 'e.clock>='.$options['time_from'];
+			$sql_parts['where'][] = 'e.clock>='.zbx_dbstr($options['time_from']);
 		}
 // time_till
 		if(!is_null($options['time_till'])){
-			$sql_parts['where'][] = 'e.clock<='.$options['time_till'];
+			$sql_parts['where'][] = 'e.clock<='.zbx_dbstr($options['time_till']);
 		}
 // value
 		if(!is_null($options['value'])){
@@ -502,12 +502,12 @@
 			$eventid = get_dbid('events','eventid');
 			$sql = 'INSERT INTO events (eventid, source, object, objectid, clock, value, acknowledged) '.
 					' VALUES ('.$eventid.','.
-								$event['source'].','.
-								$event['object'].','.
-								$event['objectid'].','.
-								$event['clock'].','.
-								$event['value'].','.
-								$event['acknowledged'].
+								zbx_dbstr($event['source']).','.
+								zbx_dbstr($event['object']).','.
+								zbx_dbstr($event['objectid']).','.
+								zbx_dbstr($event['clock']).','.
+								zbx_dbstr($event['value']).','.
+								zbx_dbstr($event['acknowledged']).
 							')';
 			$result = DBexecute($sql);
 			if(!$result) break;
@@ -625,7 +625,7 @@
 			foreach($events as $enum => $event){
 				$acknowledgeid = get_dbid('acknowledges', 'acknowledgeid');
 				$result = DBexecute('INSERT INTO acknowledges (acknowledgeid, userid, eventid, clock, message)'.
-					' VALUES ('.$acknowledgeid.','.$USER_DETAILS['userid'].','.$event['eventid'].','.$time.','.$message.')');
+					' VALUES ('.$acknowledgeid.','.$USER_DETAILS['userid'].','.zbx_dbstr($event['eventid']).','.$time.','.$message.')');
 
 				if(!$result)
 					break;
Index: frontends/php/api/classes/class.cimage.php
===================================================================
--- frontends/php/api/classes/class.cimage.php	(revision 38884)
+++ frontends/php/api/classes/class.cimage.php	(working copy)
@@ -152,13 +152,13 @@
 			zbx_value2array($options['filter']);
 
 			if(isset($options['filter']['imageid']))
-				$sql_parts['where']['imageid'] = 'i.imageid='.$options['filter']['imageid'];
+				$sql_parts['where']['imageid'] = 'i.imageid='.zbx_dbstr($options['filter']['imageid']);
 
 			if(isset($options['filter']['name']))
 				$sql_parts['where']['name'] = 'i.name='.zbx_dbstr($options['filter']['name']);
 
 			if(isset($options['filter']['imagetype']))
-				$sql_parts['where']['imagetype'] = 'i.imagetype='.$options['filter']['imagetype'];
+				$sql_parts['where']['imagetype'] = 'i.imagetype='.zbx_dbstr($options['filter']['imagetype']);
 		}
 
 // order
@@ -361,7 +361,7 @@
 				if($DB['TYPE'] == 'POSTGRESQL'){
 					$image['image'] = pg_escape_bytea($image['image']);
 					$sql = 'INSERT INTO images (imageid, name, imagetype, image) '.
-									' VALUES ('.$imageid.','.zbx_dbstr($image['name']).','.$image['imagetype'].",'".$image['image']."')";
+									' VALUES ('.$imageid.','.zbx_dbstr($image['name']).','.zbx_dbstr($image['imagetype']).",'".$image['image']."')";
 					$result = (bool) DBexecute($sql);
 				}
 				else if($DB['TYPE'] == 'ORACLE'){
@@ -369,7 +369,7 @@
 					$lobimage = OCINewDescriptor($DB['DB'], OCI_D_LOB);
 
 					$stid = OCIParse($DB['DB'], 'INSERT INTO images (imageid,name,imagetype,image)'.
-						' VALUES ('.$imageid.','.zbx_dbstr($image['name']).','.$image['imagetype'].",EMPTY_BLOB())".
+						' VALUES ('.$imageid.','.zbx_dbstr($image['name']).','.zbx_dbstr($image['imagetype']).",EMPTY_BLOB())".
 						' RETURN image INTO :image');
 
 					if(!$stid){
@@ -397,7 +397,7 @@
 					$values = array(
 						'imageid' => $imageid,
 						'name' => zbx_dbstr($image['name']),
-						'imagetype' => $image['imagetype'],
+						'imagetype' => zbx_dbstr($image['imagetype']),
 						'image' => zbx_dbstr($image['image'])
 					);
 
Index: frontends/php/api/classes/class.cmaintenance.php
===================================================================
--- frontends/php/api/classes/class.cmaintenance.php	(revision 38884)
+++ frontends/php/api/classes/class.cmaintenance.php	(working copy)
@@ -377,7 +377,7 @@
 
 		$sql = 'SELECT m.maintenanceid '.
 				' FROM maintenances m '.
-				' WHERE m.name='.$maintenance['name'];
+				' WHERE m.name='.zbx_dbstr($maintenance['name']);
 		$res = DBselect($sql);
 		while($maintenance = DBfetch($res)){
 			$maintenanceids[$maintenance['maintenanceid']] = $maintenance['maintenanceid'];
Index: frontends/php/api/classes/class.chostgroup.php
===================================================================
--- frontends/php/api/classes/class.chostgroup.php	(revision 38884)
+++ frontends/php/api/classes/class.chostgroup.php	(working copy)
@@ -272,7 +272,7 @@
 			zbx_value2array($options['filter']);
 
 			if(isset($options['filter']['groupid']))
-				$sql_parts['where']['groupid'] = 'g.groupid='.$options['filter']['groupid'];
+				$sql_parts['where']['groupid'] = 'g.groupid='.zbx_dbstr($options['filter']['groupid']);
 
 			if(isset($options['filter']['name']))
 				$sql_parts['where']['name'] = 'g.name='.zbx_dbstr($options['filter']['name']);
@@ -623,7 +623,7 @@
 				break;
 			}
 
-			$sql = 'UPDATE groups SET name='.zbx_dbstr($group['name']).' WHERE groupid='.$group['groupid'];
+			$sql = 'UPDATE groups SET name='.zbx_dbstr($group['name']).' WHERE groupid='.zbx_dbstr($group['groupid']);
 			if(!DBexecute($sql)){
 				$result = false;
 				break;
@@ -860,7 +860,7 @@
 			foreach($objectids as $hostid){
 				if(isset($linked[$groupid]) && isset($linked[$groupid][$hostid])) continue;
 				$hostgroupid = get_dbid('hosts_groups', 'hostgroupid');
-				$result = DBexecute("INSERT INTO hosts_groups (hostgroupid, hostid, groupid) VALUES ($hostgroupid, $hostid, $groupid)");
+				$result = DBexecute("INSERT INTO hosts_groups (hostgroupid, hostid, groupid) VALUES ($hostgroupid, ".zbx_dbstr($hostid).", ".zbx_dbstr($groupid).")");
 				if(!$result){
 					break 2;
 				}
@@ -1087,7 +1087,7 @@
 		foreach($groupids as $gnum => $groupid){
 			foreach($objectids_to_link as $objectid){
 				$hostgroupid = get_dbid('hosts_groups', 'hostgroupid');
-				$result = DBexecute("INSERT INTO hosts_groups (hostgroupid, hostid, groupid) VALUES ($hostgroupid, $objectid, $groupid)");
+				$result = DBexecute("INSERT INTO hosts_groups (hostgroupid, hostid, groupid) VALUES ($hostgroupid, ".zbx_dbstr($objectid).", ".zbx_dbstr($groupid).")");
 				if(!$result){
 					break 2;
 				}
Index: frontends/php/api/classes/class.cusergroup.php
===================================================================
--- frontends/php/api/classes/class.cusergroup.php	(revision 38884)
+++ frontends/php/api/classes/class.cusergroup.php	(working copy)
@@ -144,7 +144,7 @@
 
 // status
 		if(!is_null($options['status'])){
-			$sql_parts['where'][] = 'g.users_status='.$options['status'];
+			$sql_parts['where'][] = 'g.users_status='.zbx_dbstr($options['status']);
 		}
 
 // with_gui_access
@@ -468,12 +468,12 @@
 		$usrgrpid = $rights['usrgrpid'];
 
 		self::BeginTransaction(__METHOD__);
-		$result=DBexecute("DELETE FROM rights WHERE groupid=".$usrgrpid);
+		$result=DBexecute("DELETE FROM rights WHERE groupid=".zbx_dbstr($usrgrpid));
 
 		foreach($rights['rights'] as $right){
 			$id = get_dbid('rights', 'rightid');
 			$result = DBexecute('INSERT INTO rights (rightid, groupid, permission, id)'.
-				' VALUES ('.$id.','.$usrgrpid.','.$right['permission'].','.$right['id'].')');
+				' VALUES ('.$id.','.zbx_dbstr($usrgrpid).','.zbx_dbstr($right['permission']).','.zbx_dbstr($right['id']).')');
 			if(!$result) break;
 		}
 
@@ -512,18 +512,18 @@
 
 		self::BeginTransaction(__METHOD__);
 		foreach($rights['rights'] as $right){
-			$sql = 'SELECT rightid, permission FROM rights WHERE groupid='.$usrgrpid.' AND id='.$right['id'];
+			$sql = 'SELECT rightid, permission FROM rights WHERE groupid='.zbx_dbstr($usrgrpid).' AND id='.zbx_dbstr($right['id']);
 			$curr_perm = DBfetch(DBselect($sql));
 
 			if($curr_perm){
 				if($curr_perm['permission'] != $right['permission']){
-					$sql = 'UPDATE rights SET permission='.$right['permission'].' WHERE rightid='.$curr_perm['rightid'];
+					$sql = 'UPDATE rights SET permission='.zbx_dbstr($right['permission']).' WHERE rightid='.zbx_dbstr($curr_perm['rightid']);
 				}
 			}
 			else{
 				$id = get_dbid('rights', 'rightid');
 				$sql = 'INSERT INTO rights (rightid, groupid, permission, id)'.
-					' VALUES ('.$id.','.$usrgrpid.','.$right['permission'].','.$right['id'].')';
+					' VALUES ('.$id.','.zbx_dbstr($usrgrpid).','.zbx_dbstr($right['permission']).','.zbx_dbstr($right['id']).')';
 			}
 
 			$result = DBexecute($sql);
@@ -603,7 +603,7 @@
 			foreach($users as $unaum => $user){
 				$users_groups_id = get_dbid('users_groups', 'id');
 				$sql = 'INSERT INTO users_groups (id, usrgrpid, userid) '.
-						' VALUES ('.$users_groups_id.','.$usrgrp['usrgrpid'].','.$user['userid'].')';
+						' VALUES ('.$users_groups_id.','.zbx_dbstr($usrgrp['usrgrpid']).','.zbx_dbstr($user['userid']).')';
 				$result = DBexecute($sql);
 				if(!$result){
 					$errors[] = array('errno' => ZBX_API_ERROR_PARAMETERS, 'error' => 'Error adding user to group');
